/*******************************************************************************************
ļ 	DS18B20¶ȴ⺯
дˣ 	콨ƽ
дʱ䣺2021  1025
Ӳ֧֣T5L0,һ߹һֻDS18B20
ӿ˵ÿֻDS18B205V磬ӿڼ4.7K
޸־
		
*******************************************************************************************/
# include <sys.h>
# include <stdio.h>
# include "Ds18b20.h"
# include "main.h"
# include "timer.h"
# include "general.h"

DS_CONTEX g_DsCxt[DS_NUM];

/*******************************************************************************************
     : void SetDSOut(u8 bIdx)
   : DSΪ
   : bIdx
   : none
 ޸ʷ  :
       : 20211025
       : xujianping
 ޸  : 
********************************************************************************************/
void SetDSOut(u8 bIdx)
{
	if(bIdx == DS_COOLING)
		SetPinOut(1,4);	//Config P1.4 as output port
	else if(bIdx == DS_FREEZING)
		SetPinOut(1,0);	//Config P1.0 as output port
	else
		SetPinOut(1,2);	//Config P1.2 as output port
}
/*******************************************************************************************
     : void SetDSIn(u8 bIdx)
   : DSΪ
   : bIdx
   : none
 ޸ʷ  :
       : 20211025
       : xujianping
 ޸  : 
********************************************************************************************/
void SetDSIn(u8 bIdx)
{
	if(bIdx == DS_COOLING)
		SetPinIn(1,4);	//Config P1.4 as input port
	else if(bIdx == DS_FREEZING)
		SetPinIn(1,0);	//Config P1.0 as input port
	else
		SetPinIn(1,2);	//Config P1.2 as input port
}

/*******************************************************************************************
     : void DSPinOut (u8 bIdx, bit bBit)
   : DSܽ1
   : bIdx,bBit:ߵƽ͵ƽ
   : none
 ޸ʷ  :
       : 20211025
       : xujianping
 ޸  : 
********************************************************************************************/
void DSPinOut (u8 bIdx, bit bBit)
{
	if(bIdx == DS_COOLING)
		PinOutput(1,4,bBit);
		//ds1 = bBit;
	else if(bIdx == DS_FREEZING)
		PinOutput(1,0,bBit);
		//ds2 = bBit;
	else
		PinOutput(1,2,bBit);
		//ds2 = bBit;
}

/*******************************************************************************************
     : void GetDSPin(u8 bIdx)
   : ȡDSܽ
   : bIdx
   : none
 ޸ʷ  :
       : 20211025
       : xujianping
 ޸  : 
********************************************************************************************/
bit GetDSPin (u8 bIdx)
{
	bit dat;
	if(bIdx == DS_COOLING)
		dat = GetPinIn(1,4);
		//dat = ds1;
	else if(bIdx == DS_FREEZING)
		dat = GetPinIn(1,0);
		//dat = ds2;
	else
		dat = GetPinIn(1,2);
		//dat = ds3;
	return dat;
}

/*******************************************************************************************
     : void Ds18b20_Init(void)
   : ʼDS18B20
   : 
   : >1ִ<1ִд
 ޸ʷ  :
       : 20211025
       : xujianping
 ޸  : 
********************************************************************************************/
void Ds18b20_Init(void)
{
	u8 i;
	SetPinOut(1,0);	//Config P1.0 as output port
	SetPinOut(1,2);	//Config P1.2 as output port
	SetPinOut(1,4);	//Config P1.4 as output port
	PinOutput(1,0,1);
	PinOutput(1,2,1);
	PinOutput(1,4,1);
	
	for(i=0; i<DS_NUM; i++)
	{
		g_DsCxt[i].enmDsState = DS_IDLE;
		g_DsCxt[i].iTempVal = 0;
	}
	
}

/*******************************************************************************************
     : s8 dsreset (u8 bIdx)
   : ߸λÿָ֮ǰ
   : bIdx,¶ȴ
   : >1ִ<1ִд
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
s8 dsreset (u8 bIdx)
{
	u16 i = 0;
	SetDSOut(bIdx);
	DSPinOut(bIdx,0);	   				// 
	delay_us(500);							// ʱ480~960usӳ೤ʱ䣬οָڣԼ
	DSPinOut(bIdx,1);						// 
	SetDSIn(bIdx);
	do{
		delay_us(10);		// ʱȴ15~60us
		i++;
		if(i > 500) return -1;	//5ms timeout
	}while(GetDSPin(bIdx));
	SetDSOut(bIdx);
	DSPinOut(bIdx,1);	   				// 
	delay_us(500);
	return 1;
}
/*******************************************************************************************
     : bit tempreadbit(u8 bIdx)
   : ȡλݺ
   : bIdx,¶ȴ
   : λ
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
bit tempreadbit(u8 bIdx)
{
	bit dat;
	SetDSOut(bIdx);
	DSPinOut(bIdx,0);	   		//	͵0
	delay_us(10);		
	SetDSIn(bIdx);
	delay_us(1);		
	dat=GetDSPin(bIdx);		//ߵõһ״̬λ
	delay_us(50);		
	SetDSOut(bIdx);
	DSPinOut(bIdx,1);	   		//	ߵ1
	delay_us(1);		

	return (dat);
}
/*******************************************************************************************
     : u8 tempread(u8 bIdx)
   : ֽݺ
   : bIdx,¶ȴ
   : ֽ
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
u8 tempread(u8 bIdx)
{
	u8 i,bi,dat;
	dat=0;
	for(i=1;i<=8;i++)
	{
		bi=tempreadbit(bIdx);
		dat = (dat >> 1) | (bi << 7);
	}	
	return (dat);
}
/*******************************************************************************************
     : void tempwritebyte(u8 bIdx,u8 dat)
   : дֽݺ
   : bIdx,¶ȴ
					 dat,Ҫдֽ
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void tempwritebyte(u8 bIdx,u8 dat)
{
	u8 i;
	bit testb;
	SetDSOut(bIdx);
	for(i=1;i<=8;i++)
	{
		DSPinOut(bIdx,0);     	 
		delay_us(15);
		if(dat & 0x01)
			DSPinOut(bIdx,1);
		delay_us(45);
		if((dat & 0x01) == 0)
			DSPinOut(bIdx,1);	
		delay_us(1);	
		dat >>= 1;
		
	}
}
#if 0
 /*******************************************************************************************
ȡ¶Ȳת
  ãtempchange()
  
ֵ
  
ע  ָͣοDS18B20ֲ
*******************************************************************************************/
s8 tempchange(u8 bIdx)
{
	u16 timeout = 0;	//
	if(dsreset(bIdx) < 0)
	{
		return -1;
	}		

	tempwritebyte(bIdx,0xcc);
	tempwritebyte(bIdx,0x44);
//	SetDSIn(bIdx);
//	do{
//		delay_ms(1);		// תУΪͣȴ߱
//		timeout++;
//		if(timeout > 1000) return -1;	//1s timeout
//	}while(GetDSPin(bIdx) == 0);
	return 1;
}
 /*******************************************************************************************
Ĵд洢¶
  ãget_temp()
  
ֵtemp
  
ע  ָͣοDS18B20ֲ
*******************************************************************************************/
u16 get_temp(u8 bIdx,u16 *adval)
{
	float f_temp;
	s16 iTemp = 0;	//
	u8 bTemp;
	
	if(tempchange() < 0)
	{
		return -99;
	}
	if(dsreset(bIdx) < 0)
	{
		return -99;
	}		
//	delay_ms(1);
	tempwritebyte(bIdx,0xcc);
	tempwritebyte(bIdx,0xbe);
	bTemp=tempread(bIdx); 			// Ͱλ
	iTemp=tempread(bIdx);		// ߰λ
	iTemp <<= 8;
	iTemp |= bTemp;			//ֽһ
	*adval = iTemp;
	f_temp=(float)iTemp*0.0625;	//¶ڼĴΪ12λֱ0.0625
	iTemp = f_temp + 0.5;	//0.5룻
	return iTemp;
}
#endif

/*******************************************************************************************
     : void DoTempPoll(u8 bIdx)
   : ѯ¶
   : none
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void DoTempPoll(u8 bIdx)
{
	switch(g_DsCxt[bIdx].enmDsState)
	{
		case DS_IDLE:
			if(dsreset(bIdx) > 0)
			{
				//ADת
				tempwritebyte(bIdx,0xcc);
				tempwritebyte(bIdx,0x44);
				g_DsCxt[bIdx].nDsLastTick = TICK_NOW;
				g_DsCxt[bIdx].enmDsState = DS_TCONVERT;
				bitFlag.all &= ~(1<<bIdx);
			}		
			else
			{
				bitFlag.all |= 1<<bIdx;
			}
			break;
		case DS_TCONVERT:
			if(TimeElapsed(g_DsCxt[bIdx].nDsLastTick,TICK_NOW) > 1000)
			{
				g_DsCxt[bIdx].enmDsState = DS_IDLE;	//timeout return to restart
				if(dsreset(bIdx) > 0)
				{
					u8 bTemp;
					s16 iTempVal;
					//ADת
					tempwritebyte(bIdx,0xcc);
					tempwritebyte(bIdx,0xbe);
					bTemp=tempread(bIdx); 			// Ͱλ
					iTempVal=tempread(bIdx);		// ߰λ
					iTempVal <<= 8;
					iTempVal |= bTemp;			//ֽһ
					g_DsCxt[bIdx].iTempAdVal = iTempVal;
					g_DsCxt[bIdx].iTempVal=(float)iTempVal * 0.0625 + 0.5;	//¶ڼĴΪ12λֱ0.0625
					g_DsCxt[bIdx].enmDsState = DS_IDLE;	//timeout return to restart
					
					#if 1
					write_dgus_vp(VP_CUR_COOLING_TEMP + bIdx,(u8*)&g_DsCxt[bIdx].iTempVal,1);	//
					#endif
				}		
			}
			
			break;
		default:
			break;
	}
	
}