#include "sys.h"
#include "iic.h"

//**********************RX8130ӿڳSDA 10K3.3V************** 
//ϵʱһinitrtc()Ȼ0.5һrdtime()ȡʱ䵽DGUSӦϵͳӿ 
#define I2CDELAY 10
void  Init_IIc_Interface(IIC_CFG *cfg)
{
	SetPinOut((cfg->SCLPort&0xf0)>>4,cfg->SCLPort&0x0f);
}

void SetSdaIn(IIC_CFG *cfg) 
{ 
    SetPinIn((cfg->SDAPort&0xf0)>>4,cfg->SDAPort&0x0f);
} 

void SetSdaOut(IIC_CFG *cfg) 
{ 
    SetPinOut((cfg->SDAPort&0xf0)>>4,cfg->SDAPort&0x0f);
} 

u8  GetSdaIn(IIC_CFG *cfg)
{
	return GetPinIn((cfg->SDAPort&0xf0)>>4,cfg->SDAPort&0x0f);
}

void SdaOutH(IIC_CFG *cfg)     
{
	PinOutput((cfg->SDAPort&0xf0)>>4,cfg->SDAPort&0x0f,1);
}

void SdaOutL(IIC_CFG *cfg)
{
	PinOutput((cfg->SDAPort&0xf0)>>4,cfg->SDAPort&0x0f,0);
}

void SckOutH(IIC_CFG *cfg)
{
	PinOutput((cfg->SCLPort&0xf0)>>4,cfg->SCLPort&0x0f,1);
}

void SckOutL(IIC_CFG *cfg)
{
	PinOutput((cfg->SCLPort&0xf0)>>4,cfg->SCLPort&0x0f,0);
}    


void i2cstart(IIC_CFG *cfg) 
{ 
		SdaOutH(cfg); 
		delay_us(I2CDELAY); 
		SckOutH(cfg); 
		delay_us(I2CDELAY); 
		SdaOutL(cfg); 
		delay_us(I2CDELAY); 
		SckOutL(cfg); 
		delay_us(I2CDELAY);
} 

void i2cstop(IIC_CFG *cfg) 
{ 
		SdaOutL(cfg); 
		delay_us(I2CDELAY); 
		SckOutH(cfg); 
		delay_us(I2CDELAY); 
		SdaOutH(cfg); 
		delay_us(I2CDELAY); 
		SckOutL(cfg); 
		delay_us(I2CDELAY); 
} 
//send 0,send ack to master
void mack(IIC_CFG *cfg) 
{ 
		SdaOutL(cfg); 
		delay_us(I2CDELAY); 
		SckOutH(cfg); 
		delay_us(I2CDELAY); 
		SckOutL(cfg); 
		delay_us(I2CDELAY); 
} 
//send 1,send nack to master
void mnak(IIC_CFG *cfg) 
{ 
		SdaOutH(cfg); 
		delay_us(I2CDELAY); 
		SckOutH(cfg); 
		delay_us(I2CDELAY); 
		SckOutL(cfg); 
		delay_us(I2CDELAY);
} 
// check ack
bit cack(IIC_CFG *cfg)
{ 

		bit ack;
		SetSdaIn(cfg); 
		SckOutH(cfg); 
		delay_us(I2CDELAY);
		ack = GetSdaIn(cfg);
		SckOutL(cfg); 
		delay_us(I2CDELAY);
		SetSdaOut(cfg); 
	
		return (!ack);
} 

//I2C д1ֽ 
bit i2cbw(u8 WData, IIC_CFG *cfg) 
{ 
		char i; 
		for(i=0;i<8;i++) 
		{ 
			if(WData&0x80) SdaOutH(cfg); 
			else SdaOutL(cfg); 
			WData=(WData<<1); 
			delay_us(I2CDELAY); 
			SckOutH(cfg); 
			delay_us(I2CDELAY); 
			SckOutL(cfg); 
			delay_us(I2CDELAY);
		} 
		return cack(cfg);
} 

//i2c ȡ1ֽ 
u8 i2cbr(IIC_CFG *cfg) 
{ 
		u8 i; 
		u8 RData = 0; 		
		SetSdaIn(cfg); 
		for(i=0;i<8;i++) 
		{ 
			SckOutH(cfg); 
			delay_us(I2CDELAY); 
			RData <<= 1; 
			if(GetSdaIn(cfg)) 
				RData |= 0x01; 
			SckOutL(cfg); 
			delay_us(I2CDELAY); 
		} 
		SetSdaOut(cfg); 
		return(RData); 
} 
	
	