#ifndef _MPH_H_
#define _MPH_H_
#include "main.h"
#define USE_YSPMA40D 0

#if (USE_YSPMA40D > 0)
#define fK  (7.50061682704f/128000)		//1KPa = 7.5188mmHg
#else
#define fK  (40.0f*7.50061682704/0x200000ul)		//1KPa = 7.50061682704mmHg
#endif

#if (USE_YSPMA40D > 0)
#define MPR_ADDR_WR 	0xDA				// 写地址
#define MPR_ADDR_RD 	0xDB				// 读地址
#else
#define MPR_ADDR_WR 	0xB0				// 写地址
#define MPR_ADDR_RD 	0xB1				// 读地址
#endif
void Mpr_Init(void);
s8 WriteByte(u8 bAddr, u8 bData) ;
s8 ReadByte(u8 bAddr,u8* pData) ;
s8 ReadNByte(u8 bAddr,u8* pData,u8 bSize) ;
#if (USE_RAW_IS_AD > 0)
s8 GetPressTemp(s32* pPress,u8* pTemp);
#else
s8 GetPressTemp(s16* pPress,u8* pTemp);
#endif
void Write_One_Byte(u8 addr, u8 thedata);

#endif

