
/******************************************************************************

                  Ȩ (C), 2019, ĿƼ޹˾

 ******************************************************************************
       : sys.h
       : V1.0
         : chenmeishu
     : 2019.9.2
     : 
  ޸ʷ   :
  1.       : 
           : 
    ޸   : 
******************************************************************************/
#ifndef __SYS_H__
#define __SYS_H__
#include "T5LOS8051.h"
#include "typedef.h"
/*****************************************
*0X16ַжϻԼ¼
*****************************************/
#define IDLE_PRESS     0//δĻ
#define FIRST_PRESS    1//״ΰ
#define UNDER_PRESS  	 2//ѹ
#define RELEASE_PRESS  3//̧


#define UNTOUCH 0              //δ
#define UNSLIDE 1              //δ
#define CLICKTOUCH 2           //¼
#define VERTICAL_SLIDE 3       //򻬶¼
#define HORIZONTAL_SLIDE 4     //򻬶¼
#define AUTOVERTICAL_SLIDE 5   //򻬶¼
#define AUTOHORIZONTAL_SLIDE 6 //򻬶¼
#define SLIDE_THRESHOLD 9 //XYıص㻬
#define ANGLE_THRESHOLD 2 //򻬶򻬶tanֵcotֵ

/*************************************************************
  memory assignment(0x0000 ~ 0xffff)

  0x0000~0x0fff  system reserved
	0x1000~0xffff  user   area
**********************************************************/
/*****************************************
*	    ϵͳӿڱַ궨 (0x0000 0x03ff  )   
*****************************************/
#define		NOR_FLASH				0x0008
#define		SOFT_VERSION		0x000F
#define		RTC						  0x0010
#define		PIC_NOW					0x0014
#define		TP_STATUS				0x0016
#define		LED_NOW					0x0031
#define		AD_VALUE				0x0032
#define   LCD_HOR         0x007A
#define   LCD_VER         0x007B
#define		LED_CONFIG			0x0082
#define		PIC_SET					0x0084
#define 	RTC_Set					0x009C   
#define   RWFLASH         0x00AA
#define   SIMULATE_TP     0x00D4
#define   ENABLE_CURSOR   0x00D8
#define   SYS_CONFIG      0x0080
#define   AUDIO_PLAY      0X00F0

#define		Dgus_Page 			PIC_NOW
#define		Dgus_PowerAd 		0x0037
#define 	Dgus_Rtc_Set		RTC_Set


/*****************************************
*			wifiӿڱַ궨        *
*****************************************/
#define   WIFI_SWITCH            0x0400
#define		RMA						         0x0401
#define		EQUIPMENT_MODEL			   0x0416
#define		QR_CODE					       0x0450
#define		DISTRIBUTION_NETWORK	 0x0498
#define		MAC_ADDR				       0x0482
#define		WIFI_VER				       0x0487
#define		DISTRIBUTION_STATUS		 0x04A1
#define		NETWORK_STATUS			   0x04A2
#define		RTC_NETWORK				     0x04AC
#define		SSID					         0x04B0
#define		WIFI_PASSWORD			     0x04C0
#define   FLASH_ACCESS_CYCLE     50

/*****************************************
*			жǷVP      *
*****************************************/
//#define INTVPACTION


/*****************************************************
0x1000     0xffff ûռ
******************************************************/
/*****************************************
vp define for ebpm
*****************************************/
#define		Dgus_Pressure_Now 						0x3000	
#define		Dgus_Pressure_Now_Display 		0x3001	
	
#define		Dgus_Power_Now 								0x3003
#define 	Dgus_Power_Level							0x3004
#define 	Dgus_Charge_Flag							0x3005
	
	
#define		Dgus_High_Pressure			 			0x3010
#define 	Dgus_Low_Pressure 			 			0x3011
#define 	Dgus_MaiBo		  			 				0x3012
#define		Dgus_High_Pressure_Flag				0x3013
#define 	Dgus_Low_Pressure_Flag 				0x3014
#define 	Dgus_MaiBo_Flag		  					0x3015
	
#define		Dgus_Human_A_B								0x3020
#define 	Dgus_Human_A_History_Count_Total		0x3021
#define 	Dgus_Human_B_History_Count_Total		0x3022
#define 	Dgus_Sound_Lv									0x3023
#define		Dgus_Light_Lv									0x3024
	
#define 	Dgus_Human_History_Count_Now	0x302A
#define 	Dgus_Clear_Histroy_Flag				0x3030
			
#define 	Dgus_HistoryYear							0x3200	//year
#define 	Dgus_HistoryMonth							0x3201	//month
#define 	Dgus_HistoryDH								0x3202	//day&hour
#define 	Dgus_HistoryMS								0x3203	//minute&second
#define 	Dgus_HistorySPB								0x3204
#define 	Dgus_HistoryDPB								0x3205
#define 	Dgus_HistoryPUL								0x3206

#define 	Dgus_Temp_vp									0x3300

#define		Dgus_Pump_Flag								0x4001
#define		Dgus_Valve_Flag								0x4002
#define		Dgus_Measure_Flag							0x4003
#define 	Dgus_Next_Flag								0x4004	
#define 	Dgus_Count										0x4005	

#define 	Dgus_Curve_BP				 					0x1000
#define 	Dgus_HistoryCurve_SBP					0x1800
#define 	Dgus_HistoryCurve_DBP					0x2000
#define 	Dgus_HistoryCurve_PUL					0x2800

//#define 	Dgus_Line1_Vp 								Dgus_HistoryCurve_SBP
//#define 	Dgus_Line2_Vp 								Dgus_HistoryCurve_DBP

#define 	Dgus_HistoryArrowBase					0x5000	//ʾ30ʷ0x5000~0x501D

#define 	Dgus_Test_Vp									0x7000
#define 	VP_PARA_CFG_ADDR_BASE					0x8000

#define 	Nor_HistoryADataCnt						0x0000
#define 	Nor_HistoryBDataCnt						0x0002
#define 	Nor_Human_A_B									0x0004

#define 	Nor_HistoryCurveA_AddrBase		0x1000
#define 	Nor_HistoryDateA_AddrBase			0x3000
#define 	Nor_HistoryTimeA_AddrBase			0x5000

#define 	Nor_HistoryCurveB_AddrBase		0x7000
#define 	Nor_HistoryDateB_AddrBase			0x9000
#define 	Nor_HistoryTimeB_AddrBase			0xB000
/*************************************************
	NORFLASH(eeprom)    read to RAM ,RAM address 
**************************************************/
#define		NORFLASH_PARA_CFG_ADDR_BASE		0x00
/*************************************************
	UI 
**************************************************/

#define FOSC     206438400UL
#define T1MS    (65536-FOSC/12/1000)
#define MS_PER_TICK	1

#define CPU_CRITICAL_ENTER() 	EA = 0;
#define CPU_CRITICAL_EXIT() 	EA = 1;

#define   READ_CARD_OK      0
#define   READ_CARD_ERR     1
#define   WITHOUT_CARD      2
#define   DATA_READY        1


#define READ		0x5A	
#define WRITE   0xA5	

#ifndef NULL
#define NULL ((void *)0)
#endif

typedef struct _mNORFLASH
{
	u8 Mode;   //0x5a=ݣ0XA5д
	u32 FLAddr;  //flashʼַΪż
	u16	VPAddr;	 //VPʼַ
	u16 Len;		 //ֽڳȣΪż
	u8 *Buf;		 //дݻָ
}MNORFLASH;

typedef struct _mSPIFLASH
{
	u8 Mode;	//5AʹSPI
	u16 ID;			//IDţڶΪ16-31
	u32 FLAddr;	//256KеĳַΪż
	u16	VPAddr;	//VPַΪż
	u16 Len;		//
	u8 *Buf;		//ݴָ
	u16 Delay;	//ִдGUIʱʱ
}MSPIFLASH;

typedef struct _mMUSIC
{
	u8 IdNmu[32];
	u8 PlayTail;
	u8 PlayHead;
	u8 PlayInterrupt;
}MMUSIC;

extern MNORFLASH Nor_Flash;
extern MSPIFLASH Spi_Flash;
extern MMUSIC MusicBuf;
extern s16 PosXChangeSpeed,PosYChangeSpeed,RealPosX,RealPosY;
extern s16 xdistance,ydistance,PressPosX,PressPosY,LastPosX,LastPosY;
extern u16 PressPageID;
extern u8 PressPosChange;
	
void INIT_CPU(void);
void write_dgus_vp(u16 addr,u8* buf,u16 len);
void read_dgus_vp(u16 addr,u8* buf,u16 len);
void NorFlash_Action(void);

void NorFlash_Write(u32 noraddr,u16 vpaddr,u8* buf,u16 len);
void NorFlash_Read(u32 noraddr,u16 vpaddr,u8* buf,u16 len);
//void T5L_Flash(u8 mod,u16 addr,s32 addr_flash,u16 len);
void delay_us(unsigned int t);
void delay_ms(unsigned int t);
void SetPinOut(u8 Port,u8 Pin);
void SetPinIn(u8 Port,u8 Pin);
void  PinOutput(u8 Port,u8 Pin,u8 value);
u8 GetPinIn(u8 Port,u8 Pin);
u16 GetPageID();
void Page_Change(u16 PageID);
void SPIFlash_Action(void);
void Music_Play(const u8 *MusicId, u8 len);
void MusicAnction(void);
void TouchSwitch(u16 PageID, u8 TouchType, u8 TouchID, u8 Status);
void MusicDirectPlay(u8 MusicId);
void ResetT5L(void);
void ClearRAM(void);
u8 GetTouchAnction(u16 PageID);
u8 GetTouchStatus(void);
#endif