/******************************************************************************

                  Ȩ (C), 2019, ĿƼ޹˾

 ******************************************************************************
       : timer.c
       : V1.0
         : chenmeishu
     : 2019.9.2
     : ʵ˶ʱ    Ӳʱ0    ʵ8ʱ
  ޸ʷ   :
  1.       : 
           : 
    ޸   : 
******************************************************************************/
#include "timer.h"

//ע⣺ֹ˽ԷЩֻýӿں
//u8  EnableTimer;   //8ʱǷʹ
//u8  OutTimeFlag;   //8ʱǷʱ
//u32 TimerTime[8];  //8ʱʱʱ
u8  EnablePWM;
u16 PWMTotal[8];
u16 PWMLow[8];
u16 PWMTicks[8];
u8  PWMPort[8];
u8  PWMPin[8];
//ע⣺ֹ˽ԷЩֻýӿں
u8 data EnableTimer;   //8ʱǷʹ
u8 data OutTimeFlag;   //8ʱǷʱ
u16 data TimerTime[8];  //8ʱʱʱ
u8 data SysTick;

u32 g_nSysTick = 0;

/*****************************************************************************
     : void T0_Init(void)
   : ʱ0ʼ	ʱ1ms
   :	 
   : 
 ޸ʷ  :
  1.       : 201992
           :  
    ޸   : 
*****************************************************************************/

void T0_Init(void)
{
	  TMOD=0x11;          //16λʱ
    //T0
    TH0=0x00;
    TL0=0x00;
    TR0=0x00;
	
	  OutTimeFlag=0;
	  EnableTimer=0;
	
    TMOD|=0x01;
    TH0=T1MS>>8;        //1msʱ
    TL0=T1MS;
    ET0=1;              //ʱ0ж
//    EA=1;               //ж
    TR0=1;              //ʱ
}

/*****************************************************************************
     : void T0_ISR_PC(void)    interrupt 1
   : ʱ0
   :	 
   : 
 ޸ʷ  :
  1.       : 201992
           : 
    ޸   : 
*****************************************************************************/
void T0_ISR_PC(void)    interrupt 1
{
	 u8 data i;
	
    EA=0;
    TH0=T1MS>>8;
    TL0=T1MS;
		SysTick++;
		for(i=0;i<8;i++)
		{
			if(EnableTimer&(0x01<<i))
			{
				TimerTime[i]--;
				if(TimerTime[i]==0)
				{
					OutTimeFlag |= 0x01<<i;
					EnableTimer &= ~(0x01<<i); 					 
				}
			}
		}
    EA=1;
}

/*****************************************************************************
     : void T2_Init(void)
   : ʱ2ʼ	ʱ1ms
   :	 
   : 
 ޸ʷ  :
  1.       : 20211013
           :  콨ƽ
    ޸   : 
*****************************************************************************/
void T2_Init(void)
{
    //T2
		EA = 0;
    TH2 = 0x00;
    TL2 = 0x00;
		T2CON = 0x70;				//12Ƶ	fCPU = 206.4384MHz fT2 = 17.2032MHz
	
		//T2 װֵ=65536-T2 ʱuS*T2 ʱƵʣMHz
		//T1MS = 65536 - 1000 * 17.2032 = 48333(0XBCCD)
	
    TH2=T1MS>>8;        //1msʱ
    TL2=T1MS;
		TRL2H=T1MS>>8; 			//װֵH
		TRL2L=T1MS;       	//װֵL//    EA=1;             //ж
    T2CON |= 0x01;      //ʱ
    ET2=1;              //ʱ2ж
	
		g_nSysTick = 0;
}

//ϵͳtickʱ
void timer2_Isr() interrupt 5
{
	EA = 0;
	TF2 = 0;
	g_nSysTick ++;
	EA = 1;
}

u32 GetTickCount(void)
{
	u32 tTickNow;

    CPU_CRITICAL_ENTER();                         /* Tell uC/OS-II that we are starting an ISR          */
		tTickNow = g_nSysTick;
    CPU_CRITICAL_EXIT();

	return (tTickNow*MS_PER_TICK);
}

/*****************************************************************************
     : void StartTimer(u8 ID, u16 nTime)
   : һʱ
   :	 u8 ID         ʱID
               u16 nTime     ʱms

   : 
 ޸ʷ  :
  1.       : 201992
           : 
    ޸   : 
*****************************************************************************/
void StartTimer(u8 ID, u16 nTime)
{
	  EA=0;
	  EnableTimer=EnableTimer|(1<<ID);
	  TimerTime[ID]=nTime;
	  OutTimeFlag&=~(1<<ID);
	  EA=1; 
}


/*****************************************************************************
     : void KillTimer(u8 ID)
   : ֹͣһʱ
   :	u8 ID  ʱID
   : 
 ޸ʷ  :
  1.       : 201992
           : 
    ޸   : 
*****************************************************************************/
void KillTimer(u8 ID)
{
	  EA=0;
	  EnableTimer&=~(1<<(ID));
	  OutTimeFlag&=~(1<<ID);
	  EA=1;
}

/*****************************************************************************
     : u8 GetTimeOutFlag(u8 ID)
   : öʱǷʱ
   :	u8 ID  ʱID
   :  0  δʱ    0  ʱ
 ޸ʷ  :
  1.       : 201992
           : 
    ޸   : 
*****************************************************************************/
u8 GetTimeOutFlag(u8 ID)
{
  u8 flag;
	EA=0;
	flag=OutTimeFlag&(1<<ID);
	EA=1;
	return flag;
	
}

#ifdef PWMENABLE
void StartPWM(u8 PWMID, u16 VPWMTotal,u16 VPWMLow,u8 Port,u8 Pin )
{
	  EA=0;
	  SetPinOut(Port,Pin);
	  PWMTicks[PWMID]=0;
	  PWMTotal[PWMID]=VPWMTotal;
    PWMLow[PWMID]=VPWMLow;
    PWMPort[PWMID]=Port;
    PWMPin[PWMID]=Pin;	
	  EnablePWM|=(1<<PWMID);
	  EA=1;
}

void StopPWM(u8 PWMID)
{
	  EA=0;
	  EnablePWM&=~(1<<PWMID);	
	  PinOutput(PWMPort[PWMID],PWMPin[PWMID],0);
	  EA=1;
}

void StopAllPWM()
{
	 u8 i;
	 EnablePWM=0;
	 for(i=0;i<8;i++)
	{
		PinOutput(PWMPort[i],PWMPin[i],0);
	}
}
#endif