#include "umath.h"

void StrCopy(u8 *str1,u8 *str2, u16 len)
{
	u16 i;
	
	if((str1==NULL)||(str2==NULL))
		return;
	for(i=0;i<len;i++)
	{
		str1[i] = str2[i];
	}
}

u8 StrCopare(u8 *str1,u8 *str2, u16 len)
{
	u16 i;
	
	if((str1==NULL)||(NULL == str2))
		return 0;
	for(i=0;i<len;i++)
	{
		if(*str1++ != *str2++)
			return 1;
	}
	return 0;
}

void StrClear(u8 *str1,u16 len)
{
	u16 i;
	
	if(str1==NULL)
		return;
	for(i=0;i<len;i++)
	{
		*str1++ = 0;
	}
}

/*****************************************************************************
     :u16 Calculate_CRC16(unsigned char *updata, unsigned char len)
   : CRC-16У
   : updata		Ҫ
			len	
			mode  0CRC      1CRCֵƵ
   : 
*****************************************************************************/
u16 Calculate_CRC16R11(unsigned char *updata, unsigned char len ,unsigned char mode)
{
    unsigned int Reg_CRC=0xffff;
    unsigned char i,j;
    for (i=0;i<len;i++)
    {
        Reg_CRC^=*updata++;
        for (j=0;j<8;j++)
        {
            if (Reg_CRC & 0x0001)
            {
               Reg_CRC=Reg_CRC>>1^0XA001;
            }
            else
            {
               Reg_CRC>>=1;
            }
        }
    }
	if(mode == 1)
	{
		*updata++ = (u8)Reg_CRC;
		*updata = (u8)(Reg_CRC>>8);
	}
	
	return Reg_CRC;
}