#ifndef  __R11__H___
#define  __R11__H___
#include "sys.h"
#define OPEAN_DISK 0
#define CLOSE_DISK 1
#define EXPORT_PDF 2

#define SUCCESS_ACTION 0
#define FAIL_ACTION 1

#define R11START_TREAT_LENGTH 8
#define MAXR11DATALENGTH 100


#define R11BUFSIZE 0x400
#define R11BUFSIZECNT 0x3ff

#define MAXLTNGTH 300
#define MAXTXTOWIFINUM 2

#define DeviceType  0x01	//01ڲflash   02TF   03U
#define HANDSHANK	0xAA	//ֳɹ

typedef struct r11rxdatabuf
{
	u8 rx_buf[R11BUFSIZE];	 
	u16 rx_head,rx_tail;
} R11RXDATABUF;


extern u8 HandShakeFlagFlash;//R11ɹ־   0δɹ  1ɹ
extern u8 HandShakeFlagTF;//R11ɹ־   0δɹ  1ɹ
extern u8 HandShakeFlagUSB;//R11ɹ־   0δɹ  1ɹ

extern u8 framenum;//֡

void u5_send_byte(u8 byte);
void u5_send_bytes(u8 *bytes,u16 len);
u8 GetR11Ack(u8 *buf, u8 Acklen);
void R11DateTreat(void);
u16 Calculate_CRC16R11(unsigned char *updata, unsigned char len ,unsigned char mode);
u8 SaveDataToR11(u32 Address, u8 *buf);
void SendToWifi(u8 *WifiMsg);
u8 ReadDatafromR11(u32 Address, u8 *buf);
u8 ExportDatafromR11(u32 Address, u32 len, u8 *name);
void RecFromWifi(void);
u8 DeleteAllR11Data(void);
u8 R11OnlineCheck(void);
#endif