#ifndef _GENERAL_H_
#define _GENERAL_H_

#define ENLOG

#define min(x,y)		((x>y)?y:x)

#ifndef TRUE
#define TRUE 		1
#define FALSE 	0
#endif

#define INTERRUPT_SAVE_AREA
#define INTERRUPT_DISABLE EA = 0;
#define INTERRUPT_ENABLE EA = 1;

#define LOG_LEVEL		5			//enabled when (level <= LOG_LEVEL)

//#define FOURYEARDAY (365+365+365+366)  //4һڵ1970~20382100ݣݲŻ
#define FOURYEARDAY 1461  //4һڵ1970~20382100ݣݲŻ
#define SECONDS_PER_DAY 86400  //һ
#define SECONDS_PER_HOUR 3600  //һ
#define TIMEZONE    8                  //ʱ 
 
typedef struct rtc_time_struct
{
    uint16_t ui8Year;       // 1970~2038
    uint8_t ui8Month;       // 1~12
    uint8_t ui8DayOfMonth;  // 1~31
    uint8_t ui8Week;
    uint8_t ui8Hour;        // 0~23
    uint8_t ui8Minute;      // 0~59
    uint8_t ui8Second;      // 0~59
   
}rtc_time_t;

// UnixʱתΪʱ
// unixTime: ҪжϵUnixʱ 
// *tempBeijing:صıʱ
// returnnone
// noteûȷж
void covUnixTimeStp2Beijing(uint32_t unixTime, rtc_time_t *tempBeijing);

// ʱתΪUnixʱ 
// year: Ҫжϵ 
// returnUnixʱ1970/1/1 00:00:00 ڵ) 
// noteûȷж
uint32_t covBeijing2UnixTimeStp(rtc_time_t *beijingTime);

u32 TimeElapsed(u32 tLast, u32 tNow);	//ms

void swap_word(u16_t* buf);
u16 crc_chk(u8* buf, u16 length);
void  LogPrint(int level, char* format, ... );
#endif