#include "gp8202.h"
#include "iic.h"

IIC_CFG GP8202;

//-------------------------------------------------------
void Init_GP8202(void)
{
	GP8202.SDAPort = PORTP33;
	GP8202.SCLPort = PORTP32;
	Init_IIc_Interface(&GP8202);
	
	i2cstart(&GP8202);	
	i2cbw(0xb0,&GP8202);
	i2cbw(0x02,&GP8202);
	mnak(&GP8202);
//	IIC_Nack();
	i2cstop(&GP8202);	
}
//----------------------------------------------------------
void change_data(u16 DAC_data)
{
	i2cstart(&GP8202);	
	i2cbw(0xb0,&GP8202);
	i2cbw(0x02,&GP8202);
	i2cbw(DAC_data%256,&GP8202);		
	i2cbw(DAC_data>>8,&GP8202);
	i2cstop(&GP8202);
}