/******************************************************************************

                  Ȩ (C), 2019, ĿƼ޹˾

 ******************************************************************************
       : modbus.c
       : V1.0
         : chengjing
     : 2019731
     : modbus salve0x03,0x060x10빦ܣЭT5modubs salveһ
			  ,дdgus vpֵַ
  ޸ʷ   :
  1.       : 
           : 
    ޸   : 
******************************************************************************/
#include "sys.h"
#include "modbus.h"
#include "uart.h"

u8 code test[]="uart send...";





/********************************
*  0ûн
*  0xA5:ʼ
*  0x5A00:
*  0x5AA5:modbusݽ
********************************/
u16 modbus_rx_status=0;
u8	Modbus_Buffer[MODBUS_BUFFER_LEN];

u16 Modbus_Salve_Addr_Val;
u16	Modbus_Mode;
u8	Modbus_Salve_Addr;


/*****************************************************************************
     : u16 crc16_modbus(u8 *dat, u16 length)
   : crc16 modbus
   :	
   : 
 ޸ʷ  :
  1.       : 
           : 
    ޸   : 
*****************************************************************************/
u16 crc16_modbus(u8 *dat, u16 length)  
{  
    u8 i;  
    u16 crc = 0xffff;        // Initial value  
    while(length--)  
    {  
        crc ^= *dat++;            // crc ^= *dat; dat++;  
        for (i = 0; i < 8; ++i)  
        {  
            if (crc & 1)  
                crc = (crc >> 1) ^ 0xA001;        // 0xA001 = reverse 0x8005  
            else  
                crc = (crc >> 1);  
        }
    }
    return crc;  
}

/*****************************************************************************
     : void Modbus_Init(void)
   : modbusʼ
   :	
   : 
 ޸ʷ  :
  1.       : 2019731
           : chengjing
    ޸   : 
*****************************************************************************/
void Modbus_Init(void)
{
	//UART5_Init();	

  UartInit(4,115200);		
	//UART5_SendStr(test,sizeof(test));
	Uatr_Send_Data(UART4,14,"UART4 INIT OK!");
	read_dgus_vp(MODBUS_MODE,(u8*)&Modbus_Mode,1);
	if(Modbus_Mode==MODBUS_SALVE)
	{
		read_dgus_vp(MODBUS_SALVE_SET_ADDR,(u8*)&Modbus_Salve_Addr_Val,1);
		Modbus_Salve_Addr=(u8)Modbus_Salve_Addr_Val;
	}
}

/*****************************************************************************
     : void Modbus_Salve_Handler(void)
   : modbus salve
			0x03:	ȡvpռ
			0x06 	дvp
			0x10	дvpռ
   :	
   : 
 ޸ʷ  :
  1.       : 2019731
           : chengjing
    ޸   : 
*****************************************************************************/
void Modbus_Salve_Handler(void)
{
	u8 cmd;
	u16 modbus_addr,modbus_len,modbus_data;
	u16 len;
	u16	modbus_crc;
	if(modbus_rx_status==0x5AA5)
	{
		if((Uart5_Rx[0]==Modbus_Salve_Addr)&&(uart5_rx_count>7))
		{
			cmd=Uart5_Rx[1];
			switch(cmd)
			{
				case	MODBUS_FC_READ_HOLDING_REGISTERS:		//0x03 ȡvpռ
					modbus_addr=(Uart5_Rx[2]<<8)|Uart5_Rx[3];
					modbus_len=(Uart5_Rx[4]<<8)|Uart5_Rx[5];
					len=modbus_len*2;
					Modbus_Buffer[0]=Uart5_Rx[0];
					Modbus_Buffer[1]=0x03;
					Modbus_Buffer[2]=len;
					read_dgus_vp((u32)modbus_addr,(u8*)&Modbus_Buffer[3],modbus_len);
					len+=3;
					modbus_crc=crc16_modbus(Modbus_Buffer,len);
					Modbus_Buffer[len]=(u8)modbus_crc;
					Modbus_Buffer[len+1]=(u8)(modbus_crc>>8);
					len+=2;
					Uart_Send_Data(UART5,len,Modbus_Buffer);
					break;
				case	MODBUS_FC_WRITE_SINGLE_REGISTER:		//0x06 	дvp
					modbus_addr=(Uart5_Rx[2]<<8)|Uart5_Rx[3];
					modbus_data=(Uart5_Rx[4]<<8)|Uart5_Rx[5];
					write_dgus_vp((u32)modbus_addr,(u8*)&modbus_data,1);
					Modbus_Buffer[0]=Uart5_Rx[0];
					Modbus_Buffer[1]=0x06;
					Modbus_Buffer[2]=Uart5_Rx[2];
					Modbus_Buffer[3]=Uart5_Rx[3];
					Modbus_Buffer[4]=0x00;
					Modbus_Buffer[5]=0x01;
					len=6;
					modbus_crc=crc16_modbus(Modbus_Buffer,len);
					Modbus_Buffer[len]=(u8)modbus_crc;
					Modbus_Buffer[len+1]=(u8)(modbus_crc>>8);
					len+=2;
					Uart_Send_Data(UART5,len,Modbus_Buffer);
					break;
				case	MODBUS_FC_WRITE_MULTIPLE_REGISTERS:		//0x10	дvpռ
					modbus_addr=(Uart5_Rx[2]<<8)|Uart5_Rx[3];
					modbus_len=(Uart5_Rx[4]<<8)|Uart5_Rx[5];
					write_dgus_vp((u32)modbus_addr,(u8*)&Uart5_Rx[7],modbus_len);
					Modbus_Buffer[0]=Uart5_Rx[0];
					Modbus_Buffer[1]=0x10;
					Modbus_Buffer[2]=Uart5_Rx[2];
					Modbus_Buffer[3]=Uart5_Rx[3];
					Modbus_Buffer[4]=Uart5_Rx[4];
					Modbus_Buffer[5]=Uart5_Rx[5];
					len=6;
					modbus_crc=crc16_modbus(Modbus_Buffer,len);
					Modbus_Buffer[len]=(u8)modbus_crc;
					Modbus_Buffer[len+1]=(u8)(modbus_crc>>8);
					len+=2;
					Uart_Send_Data(UART5,len,Modbus_Buffer);
					break;
				default:
					break;
			}
			modbus_rx_status=0;
			uart5_rx_count=0;
		}
	}
}


































