#ifndef _RX8130_H_
#define _RX8130_H_

//检查8130有没有掉电，掉电则初始化8130，设置时间为2017.01.01 星期一 00:00:00
void Rx8130_Init(void);

/******************************
 * 星期1-7表示星期一到星期天
 * 除星期外，其余都是要写入的BCD码
 * *************************/
void Rx8130_SetTime(u8 *prtc_set);

//把RTC读取并处理，写到DGUS对应的变量空间，主程序中每0.5秒调用一次
//星期改为 1-7，单独用数字显示，不采用RTC控件中的星期
void Rx8130_GetTime(u8 *pRtcData);

u8 GetWeek(u8 year,u8 month,u8 day);

#endif







