#ifndef __TYPEDEF_H__
#define __TYPEDEF_H__

typedef	signed  	char 	s8;
typedef signed		int  	s16;
typedef signed  	long 	s32;
typedef unsigned  char 	u8;
typedef unsigned  int  	u16;
typedef unsigned  long 	u32;

typedef unsigned 	char	u_char;		//jason, 2007-08-08
typedef unsigned 	short	u_short;	//jason, 2007-08-08
	
typedef unsigned 	char	u8_t;
typedef signed 		char	s8_t;
typedef unsigned 	short	u16_t;
typedef signed 		short	s16_t;
typedef unsigned 	long		u32_t;
typedef signed 		long		s32_t;
	
typedef unsigned 	char	uint8;
typedef signed 		char	int8;
typedef unsigned 	short	uint16;
typedef signed 		short	int16;
typedef unsigned 	long		uint32;
typedef signed 		long		int32;
typedef float          	fp32;                                            	/*  ȸ32λȣ    */
typedef double         	fp64;                                            	/*  ˫ȸ64λȣ    */

typedef unsigned 	char	uint8_t;
typedef signed 		char	int8_t;
typedef unsigned 	short	uint16_t;
typedef signed 		short	int16_t;
typedef unsigned 	long		uint32_t;
typedef signed 		long		int32_t;

#endif
